#ifndef _FSNMP_H
#define _FSNMP_H

#include "list.h"

u_char *fsnmp_build_packet(struct snmp_pdu *, u_char *, 
		size_t *, int *);

struct fsnmp_packet;

struct fsnmp_transport {
	struct fsnmp_transport	*next;
	int			socket,
				refcount;	
	struct quickfind	*ppreqid;
};

struct fsnmp_session {
	struct fsnmp_session		*next, *prev;

	char				*host,
					*community;
	int				version,
					port,
					timeout,
					backoff,
					maxretransmits,
					snmpversion,
					ptotal,
					ppending,
					ppendingmax,
					finished;
	struct sockaddr_in		saddr;
	struct fsnmp_transport		*transport;
	LIST_HEAD(struct fsnmp_packet)	packets_queued;
};

struct fsnmp_packet {
	struct fsnmp_packet	*next, *prev;
	struct fsnmp_session	*session;
	struct snmp_pdu		*pdu;
	struct timeval		sent;
	int			retransmits;
	char			*ureqid;
	oid			oid[MAX_OID_LEN];
	int			oidlen;
};

#endif
