#ifndef _LIST_H_
#define _LIST_H_

#define LIST_HEAD(type)			\
	struct {					\
		type	*next, *prev;	\
	}						

#undef LIST_DEBUG
#ifdef LIST_DEBUG
#define LIST_PRINTF(s, v...)	printf(s, v)
#else
#define	LIST_PRINTF(s, v...)
#endif

#define LIST_INIT(listhead)	do {		\
	LIST_PRINTF("LIST_INIT(%p)\n", listhead); \
	(listhead)->next = (void *) (listhead);	\
	(listhead)->prev = (void *) (listhead);	\
	} while(0)

#define LIST_ADD(list, element) do {		\
		LIST_PRINTF("LIST_ADD(%p, %p)\n", list, element);\
		(element)->next=(list)->next;		\
		(list)->next->prev=(element);		\
		(list)->next=(element);				\
		(element)->prev=(void *) (list);	\
		} while(0)	

#define LIST_APPEND(list, element) do {		\
		LIST_PRINTF("LIST_APPEND(%p, %p)\n", list, element);\
		(element)->prev=(list)->prev;		\
		(list)->prev->next=(element);		\
		(list)->prev=(element);				\
		(element)->next=(void *) (list);	\
		} while(0)

#define	LIST_DELETE(element) do {				\
		LIST_PRINTF("LIST_DELETE(%p)\n", element);\
		(element)->next->prev=(element)->prev;	\
		(element)->prev->next=(element)->next;	\
		} while(0)

#define	LIST_EMPTY(list)					\
		((list)->prev == (void *) (list))

#define LIST_FIRST(list) \
		(list)->next;

#define LIST_WALK(list, element) \
		for (element=(list)->next;\
			element != (void *) (list);\
			element = element->next)

#endif
