
#include <malloc.h>
#include <assert.h>

#include "quickfind.h"

int insertkey(struct quickfind *q, unsigned long key, void *data) {
	int	i,
		index;	

	/* Traverse until byte 3 */
	for(i=0;i<2;i++) {
		index=(key>>(i*8)) & 0xff;
		if (!(q->qf[index])) {
			q->qf[index]=malloc(sizeof(struct quickfind));
			memset(q->qf[index], 0, sizeof(struct quickfind));
			q->inuse++;
		}
		q=q->qf[index];
	}

	/* Get topmost byte */
	index=(key>>24) & 0xff;

	if(!q->qf[index])
		q->inuse++;

	q->qf[index]=data;

	return(0);
}

void *deletekey(struct quickfind *q, unsigned long key) {
	int			i,
				index;
	void			*data;

	/* Traverse until byte 3 */
	for(i=0;i<2;i++) {
		index=(key>>(i*8)) & 0xff;
		if (!q->qf[index]) 
			return(NULL);
		q=q->qf[index];
	}

	/* Get topmost byte */
	index=(key>>24) & 0xff;

	data=q->qf[index];
	q->qf[index]=NULL;

	/* Only decrement inuse if we really deleted an entry
	 * and not return an already deleted one
	 */
	if (data) 
		q->inuse--;

	/* FIXME If inuse drops to 0 free this and traverse to top
	 * otherwise we are not freeing all memory allocated - Probably
	 * not a real problem */

	return(data);
}

struct quickfind *createqf() {
	struct quickfind	*qf;

	assert((qf=malloc(sizeof(struct quickfind))));
	memset(qf, 0, sizeof(struct quickfind));

	return(qf);
}
